diff --git a/pkg/virt-handler/hotplug-disk/mount_test.go b/pkg/virt-handler/hotplug-disk/mount_test.go
index 66bae2924..5bcc3995f 100644
--- a/pkg/virt-handler/hotplug-disk/mount_test.go
+++ b/pkg/virt-handler/hotplug-disk/mount_test.go
@@ -22,11 +22,19 @@ package hotplug_volume
 import (
 	"encoding/json"
 	"fmt"
+	"io/fs"
 	"io/ioutil"
 	"os"
 	"path/filepath"
 	"reflect"
 	"strings"
+	"syscall"
+	"time"
+
+	"golang.org/x/sys/unix"
+
+	"kubevirt.io/kubevirt/pkg/safepath"
+	"kubevirt.io/kubevirt/pkg/unsafepath"
 
 	. "github.com/onsi/ginkgo"
 	"github.com/onsi/ginkgo/extensions/table"
@@ -38,7 +46,6 @@ import (
 	"k8s.io/apimachinery/pkg/types"
 
 	v1 "kubevirt.io/api/core/v1"
-	"kubevirt.io/client-go/log"
 	hotplugdisk "kubevirt.io/kubevirt/pkg/hotplug-disk"
 	"kubevirt.io/kubevirt/pkg/virt-handler/isolation"
 )
@@ -49,9 +56,11 @@ const (
 
 var (
 	tempDir              string
+	tmpDirSafe           *safepath.Path
 	orgIsoDetector       = isolationDetector
 	orgDeviceBasePath    = deviceBasePath
-	orgStatCommand       = statCommand
+	orgStatSourceCommand = statSourceDevice
+	orgStatCommand       = statDevice
 	orgCgroupsBasePath   = cgroupsBasePath
 	orgMknodCommand      = mknodCommand
 	orgSourcePodBasePath = sourcePodBasePath
@@ -102,7 +111,7 @@ var _ = Describe("HotplugVolume mount target records", func() {
 	AfterEach(func() {
 		os.RemoveAll(tempDir)
 		deviceBasePath = orgDeviceBasePath
-		statCommand = orgStatCommand
+		statSourceDevice = orgStatSourceCommand
 		cgroupsBasePath = orgCgroupsBasePath
 		mknodCommand = orgMknodCommand
 	})
@@ -151,7 +160,7 @@ var _ = Describe("HotplugVolume mount target records", func() {
 		Expect(err).ToNot(HaveOccurred())
 		res, err := m.getMountTargetRecord(vmi)
 		Expect(err).ToNot(HaveOccurred())
-		Expect(res).To(Equal(&vmiMountTargetRecord{}))
+		Expect(res).To(Equal(&vmiMountTargetRecord{UsesSafePaths: true}))
 	})
 
 	It("deleteMountTargetRecord should remove both record file and entry file", func() {
@@ -179,13 +188,15 @@ var _ = Describe("HotplugVolume block devices", func() {
 	BeforeEach(func() {
 		tempDir, err = ioutil.TempDir("", "hotplug-volume-test")
 		Expect(err).ToNot(HaveOccurred())
+		tmpDirSafe, err = safepath.JoinAndResolveWithRelativeRoot(tempDir)
+		Expect(err).ToNot(HaveOccurred())
 		vmi = api.NewMinimalVMI("fake-vmi")
 		vmi.UID = "1234"
 		activePods := make(map[types.UID]string, 0)
 		activePods["abcd"] = "host"
 		vmi.Status.ActivePods = activePods
 
-		targetPodPath = filepath.Join(tempDir, "abcd/volumes/kubernetes.io~empty-dir/hotplug-disks/testvolume")
+		targetPodPath = filepath.Join(tempDir, "abcd/volumes/kubernetes.io~empty-dir/hotplug-disks/")
 		err = os.MkdirAll(targetPodPath, 0755)
 		Expect(err).ToNot(HaveOccurred())
 
@@ -198,14 +209,14 @@ var _ = Describe("HotplugVolume block devices", func() {
 		}
 		record = &vmiMountTargetRecord{}
 
-		deviceBasePath = func(sourceUID types.UID) string {
-			return filepath.Join(tempDir, string(sourceUID), "volumes")
+		deviceBasePath = func(sourceUID types.UID) (*safepath.Path, error) {
+			return newDir(tempDir, string(sourceUID), "volumes")
 		}
-		statCommand = func(fileName string) ([]byte, error) {
-			return []byte("6,6,0777,block special file"), nil
+		statSourceDevice = func(*safepath.Path) (os.FileInfo, error) {
+			return fakeStat(true, 0777, 123456), nil
 		}
-		cgroupsBasePath = func() string {
-			return tempDir
+		cgroupsBasePath = func() (*safepath.Path, error) {
+			return tmpDirSafe, nil
 		}
 
 	})
@@ -213,7 +224,8 @@ var _ = Describe("HotplugVolume block devices", func() {
 	AfterEach(func() {
 		os.RemoveAll(tempDir)
 		deviceBasePath = orgDeviceBasePath
-		statCommand = orgStatCommand
+		statSourceDevice = orgStatSourceCommand
+		statDevice = orgStatCommand
 		cgroupsBasePath = orgCgroupsBasePath
 		mknodCommand = orgMknodCommand
 		isBlockDevice = orgIsBlockDevice
@@ -266,20 +278,19 @@ var _ = Describe("HotplugVolume block devices", func() {
 
 	It("mountBlockHotplugVolume and unmountBlockHotplugVolumes should make appropriate calls", func() {
 		blockSourcePodUID := types.UID("fghij")
-		mknodCommand = func(deviceName string, major, minor int64, blockDevicePermissions string) ([]byte, error) {
-			Expect(os.MkdirAll(deviceName, 0755)).To(Succeed())
-			return []byte("Yay"), nil
+		mknodCommand = func(basePath *safepath.Path, deviceName string, dev uint64, blockDevicePermissions os.FileMode) error {
+			_, err := newFile(unsafepath.UnsafeAbsolute(basePath.Raw()), deviceName)
+			Expect(err).ToNot(HaveOccurred())
+			return nil
 		}
-		isBlockDevice = func(path string) (bool, error) {
-			if strings.Contains(path, string(vmi.UID)) {
-				return true, nil
-			}
-			return false, fmt.Errorf("Not a block device")
+		isBlockDevice = func(path *safepath.Path) (bool, error) {
+			return strings.Contains(unsafepath.UnsafeAbsolute(path.Raw()), "blockvolume"), nil
 		}
 		targetPodPath := hotplugdisk.TargetPodBasePath(tempDir, m.findVirtlauncherUID(vmi))
 		err = os.MkdirAll(targetPodPath, 0755)
 		Expect(err).ToNot(HaveOccurred())
-		deviceFile := filepath.Join(tempDir, string(blockSourcePodUID), "volumes", "testvolume", "file")
+		deviceFile, err := newFile(tempDir, string(blockSourcePodUID), "volumes", "testvolume", "file")
+		Expect(err).ToNot(HaveOccurred())
 		slicePath := "slice"
 		m.podIsolationDetector = &mockIsolationDetector{
 			slice: slicePath,
@@ -289,16 +300,23 @@ var _ = Describe("HotplugVolume block devices", func() {
 		devicesFile := filepath.Join(tempDir, slicePath, "devices.list")
 		allowFile := filepath.Join(tempDir, slicePath, "devices.allow")
 		denyFile := filepath.Join(tempDir, slicePath, "devices.deny")
-		_, err := os.Create(allowFile)
+		_, err = os.Create(allowFile)
 		Expect(err).ToNot(HaveOccurred())
 		_, err = os.Create(denyFile)
 		Expect(err).ToNot(HaveOccurred())
 		_, err = os.Create(devicesFile)
 		Expect(err).ToNot(HaveOccurred())
-		err = os.MkdirAll(filepath.Dir(deviceFile), 0755)
-		Expect(err).ToNot(HaveOccurred())
-		err = ioutil.WriteFile(deviceFile, []byte("test"), 0644)
+		err = ioutil.WriteFile(unsafepath.UnsafeAbsolute(deviceFile.Raw()), []byte("test"), 0644)
 		Expect(err).ToNot(HaveOccurred())
+		statSourceDevice = func(fileName *safepath.Path) (os.FileInfo, error) {
+			return fakeStat(true, 0666, 123456), nil
+		}
+		statDevice = func(fileName *safepath.Path) (os.FileInfo, error) {
+			return fakeStat(true, 0666, 123456), nil
+		}
+		isBlockDevice = func(fileName *safepath.Path) (bool, error) {
+			return true, nil
+		}
 		err = m.mountBlockHotplugVolume(vmi, "testvolume", blockSourcePodUID, record)
 		Expect(err).ToNot(HaveOccurred())
 		By("Verifying the block file exists")
@@ -307,21 +325,23 @@ var _ = Describe("HotplugVolume block devices", func() {
 		By("Verifying the correct values are written to the allow file")
 		content, err := ioutil.ReadFile(allowFile)
 		Expect(err).ToNot(HaveOccurred())
-		Expect("b 6:6 rwm").To(Equal(string(content)))
+		Expect("b 482:64 rwm").To(Equal(string(content)))
 
 		By("Unmounting, we verify the reverse process happens")
-		err = m.unmountBlockHotplugVolumes(filepath.Join(targetPodPath, "testvolume"), vmi)
+		path, err := safepath.JoinAndResolveWithRelativeRoot(targetPodPath, "testvolume")
+		Expect(err).ToNot(HaveOccurred())
+		err = m.unmountBlockHotplugVolumes(path, vmi)
 		Expect(err).ToNot(HaveOccurred())
 		content, err = ioutil.ReadFile(denyFile)
 		Expect(err).ToNot(HaveOccurred())
-		Expect("b 6:6 rwm").To(Equal(string(content)))
+		Expect("b 482:64 rwm").To(Equal(string(content)))
 		_, err = os.Stat(filepath.Join(targetPodPath, "testvolume"))
 		Expect(err).To(HaveOccurred())
 	})
 
 	It("getSourceMajorMinor should return an error if no uid", func() {
 		vmi.UID = ""
-		_, _, _, err := m.getSourceMajorMinor("fghij", "invalid")
+		_, _, err := m.getSourceMajorMinor("fghij", "invalid")
 		Expect(err).To(HaveOccurred())
 	})
 
@@ -331,80 +351,42 @@ var _ = Describe("HotplugVolume block devices", func() {
 		Expect(err).ToNot(HaveOccurred())
 		err = ioutil.WriteFile(deviceFile, []byte("test"), 0644)
 		Expect(err).ToNot(HaveOccurred())
-		major, minor, perm, err := m.getSourceMajorMinor("fghij", "test-volume")
+		numbers, perm, err := m.getSourceMajorMinor("fghij", "test-volume")
 		Expect(err).ToNot(HaveOccurred())
-		Expect(major).To(Equal(int64(6)))
-		Expect(minor).To(Equal(int64(6)))
-		Expect(perm).To(Equal("0777"))
+		Expect(unix.Major(numbers)).To(Equal(uint32(482)))
+		Expect(unix.Minor(numbers)).To(Equal(uint32(64)))
+		Expect(perm & 0777).To(Equal(os.FileMode(0777)))
 	})
 
 	It("getSourceMajorMinor should return error if file doesn't exists", func() {
 		deviceFile := filepath.Join(tempDir, "fghij", "volumes", "file")
 		err = os.MkdirAll(filepath.Dir(deviceFile), 0755)
 		Expect(err).ToNot(HaveOccurred())
-		major, minor, perm, err := m.getSourceMajorMinor("fghij", "test-volume")
+		_, _, err := m.getSourceMajorMinor("fghij", "test-volume")
 		Expect(err).To(HaveOccurred())
-		Expect(major).To(Equal(int64(-1)))
-		Expect(minor).To(Equal(int64(-1)))
-		Expect(perm).To(Equal(""))
+		Expect(os.IsNotExist(err)).To(BeTrue())
 	})
 
-	It("isBlockFile should return proper value based on stat command", func() {
-		testFileName := "test-file"
-		statCommand = func(fileName string) ([]byte, error) {
-			Expect(testFileName).To(Equal(fileName))
-			return []byte("6,6,0777,block special file"), nil
-		}
-		Expect(m.isBlockFile(testFileName)).To(BeTrue())
-		statCommand = func(fileName string) ([]byte, error) {
-			Expect(testFileName).To(Equal(fileName))
-			return []byte("6,6,0777,block special file"), fmt.Errorf("Error")
-		}
-		Expect(m.isBlockFile(testFileName)).To(BeFalse())
-		statCommand = func(fileName string) ([]byte, error) {
-			Expect(testFileName).To(Equal(fileName))
-			return []byte("6,6,0777"), nil
-		}
-		Expect(m.isBlockFile(testFileName)).To(BeFalse())
-		statCommand = func(fileName string) ([]byte, error) {
-			Expect(testFileName).To(Equal(fileName))
-			return []byte("6,6,0777,block special"), nil
-		}
-		Expect(m.isBlockFile(testFileName)).To(BeFalse())
-	})
-
-	table.DescribeTable("Should return proper values", func(stat func(fileName string) ([]byte, error), major, minor int, perm string, expectErr bool) {
-		testFileName := "test-file"
-		statCommand = stat
-		majorRes, minorRes, permRes, err := m.getBlockFileMajorMinor(testFileName)
+	table.DescribeTable("Should return proper values", func(stat func(safePath *safepath.Path) (os.FileInfo, error), major, minor uint32, perm os.FileMode, expectErr bool) {
+		statSourceDevice = stat
+		testFileName, err := newFile(tempDir, "test-file")
+		Expect(err).ToNot(HaveOccurred())
+		numbers, permRes, err := m.getBlockFileMajorMinor(testFileName, statSourceDevice)
 		if expectErr {
 			Expect(err).To(HaveOccurred())
 		} else {
 			Expect(err).ToNot(HaveOccurred())
 		}
-		// Values are translated to hex (245->580, 32->50)
-		Expect(int64(major)).To(Equal(majorRes))
-		Expect(int64(minor)).To(Equal(minorRes))
-		Expect(perm).To(Equal(permRes))
+		Expect(unix.Major(numbers)).To(Equal(major))
+		Expect(unix.Minor(numbers)).To(Equal(minor))
+		Expect(perm).To(Equal(permRes & 0777))
 	},
-		table.Entry("Should return values if stat command successful", func(fileName string) ([]byte, error) {
-			return []byte("245,32,0664,block special file"), nil
-		}, 581, 50, "0664", false),
-		table.Entry("Should not return values if stat command errors", func(fileName string) ([]byte, error) {
-			return []byte("245,32,0664,block special file"), fmt.Errorf("Error")
-		}, -1, -1, "", true),
-		table.Entry("Should not return values if stat command doesn't return 4 fields", func(fileName string) ([]byte, error) {
-			return []byte("245,32,0664"), nil
-		}, -1, -1, "", true),
-		table.Entry("Should not return values if stat command doesn't return block special file", func(fileName string) ([]byte, error) {
-			return []byte("245,32,0664, block file"), nil
-		}, -1, -1, "", true),
-		table.Entry("Should not return values if stat command doesn't int major", func(fileName string) ([]byte, error) {
-			return []byte("kk,32,0664,block special file"), nil
-		}, -1, -1, "", true),
-		table.Entry("Should not return values if stat command doesn't int minor", func(fileName string) ([]byte, error) {
-			return []byte("254,gg,0664,block special file"), nil
-		}, -1, -1, "", true),
+		table.Entry("Should return values if stat command successful", func(safePath *safepath.Path) (os.FileInfo, error) {
+			return fakeStat(true, 0664, 123456), nil
+		}, uint32(482), uint32(64), os.FileMode(0664), false),
+		table.Entry("Should not return error if stat command errors", func(safePath *safepath.Path) (os.FileInfo, error) {
+			return fakeStat(true, 0664, 123456), fmt.Errorf("Error")
+		}, uint32(0), uint32(0), os.FileMode(0), true),
 	)
 
 	It("getTargetCgroupPath should return cgroup path", func() {
@@ -417,7 +399,9 @@ var _ = Describe("HotplugVolume block devices", func() {
 		Expect(err).ToNot(HaveOccurred())
 		path, err := m.getTargetCgroupPath(vmi)
 		Expect(err).ToNot(HaveOccurred())
-		Expect(path).To(Equal(filepath.Join(tempDir, slicePath)))
+		expectedPath, err := safepath.JoinNoFollow(tmpDirSafe, slicePath)
+		Expect(err).ToNot(HaveOccurred())
+		Expect(path).To(Equal(expectedPath))
 	})
 
 	It("getTargetCgroupPath should return error if detect returns error", func() {
@@ -464,71 +448,66 @@ var _ = Describe("HotplugVolume block devices", func() {
 		Expect(err).ToNot(HaveOccurred())
 		_, err = os.Create(denyFile)
 		Expect(err).ToNot(HaveOccurred())
-		err = m.allowBlockMajorMinor(34, 53, filepath.Dir(allowFile))
+		err = m.allowBlockMajorMinor(unix.Mkdev(482, 64), tmpDirSafe)
 		Expect(err).ToNot(HaveOccurred())
 		content, err := ioutil.ReadFile(allowFile)
 		Expect(err).ToNot(HaveOccurred())
-		Expect("b 34:53 rwm").To(Equal(string(content)))
+		Expect("b 482:64 rwm").To(Equal(string(content)))
 
-		err = m.removeBlockMajorMinor(34, 53, filepath.Dir(denyFile))
+		err = m.removeBlockMajorMinor(unix.Mkdev(482, 64), tmpDirSafe)
 		Expect(err).ToNot(HaveOccurred())
 		content, err = ioutil.ReadFile(denyFile)
 		Expect(err).ToNot(HaveOccurred())
-		Expect("b 34:53 rwm").To(Equal(string(content)))
+		Expect("b 482:64 rwm").To(Equal(string(content)))
 	})
 
 	It("Should error if allow/deny cannot be found", func() {
-		allowFile := filepath.Join(tempDir, "devices.allow")
-		denyFile := filepath.Join(tempDir, "devices.deny")
-		err = m.allowBlockMajorMinor(34, 53, filepath.Dir(allowFile))
+		err = m.allowBlockMajorMinor(unix.Mkdev(482, 64), tmpDirSafe)
 		Expect(err).To(HaveOccurred())
 
-		err = m.removeBlockMajorMinor(34, 53, filepath.Dir(denyFile))
+		err = m.removeBlockMajorMinor(unix.Mkdev(482, 64), tmpDirSafe)
 		Expect(err).To(HaveOccurred())
 	})
 
 	It("Should attempt to create a block device file if it doesn't exist", func() {
-		testFile := filepath.Join(tempDir, "testfile")
-		testMajor := int64(100)
-		testMinor := int64(53)
-		testPerm := "0664"
-		mknodCommand = func(deviceName string, major, minor int64, blockDevicePermissions string) ([]byte, error) {
-			Expect(deviceName).To(Equal(testFile))
-			Expect(major).To(Equal(testMajor))
-			Expect(minor).To(Equal(testMinor))
+		testMajor := uint32(482)
+		testMinor := uint32(64)
+		testPerm := os.FileMode(0664)
+		mknodCommand = func(basePath *safepath.Path, deviceName string, dev uint64, blockDevicePermissions os.FileMode) error {
+			Expect(basePath).To(Equal(tmpDirSafe))
+			Expect(deviceName).To(Equal("testfile"))
+			Expect(unix.Major(dev)).To(Equal(testMajor))
+			Expect(unix.Minor(dev)).To(Equal(testMinor))
 			Expect(blockDevicePermissions).To(Equal(testPerm))
-			return []byte("Yay"), nil
+			return nil
 		}
-		res, err := m.createBlockDeviceFile(testFile, testMajor, testMinor, testPerm)
+		err := m.createBlockDeviceFile(tmpDirSafe, "testfile", 123456, testPerm)
 		Expect(err).ToNot(HaveOccurred())
-		Expect(res).To(Equal(testFile))
 
-		mknodCommand = func(deviceName string, major, minor int64, blockDevicePermissions string) ([]byte, error) {
-			Expect(deviceName).To(Equal(testFile))
-			Expect(major).To(Equal(testMajor))
-			Expect(minor).To(Equal(testMinor))
+		mknodCommand = func(basePath *safepath.Path, deviceName string, dev uint64, blockDevicePermissions os.FileMode) error {
+			Expect(basePath).To(Equal(tmpDirSafe))
+			Expect(deviceName).To(Equal("testfile"))
+			Expect(unix.Major(dev)).To(Equal(testMajor))
+			Expect(unix.Minor(dev)).To(Equal(testMinor))
 			Expect(blockDevicePermissions).To(Equal(testPerm))
-			return []byte("Yay"), fmt.Errorf("Error creating block file")
+			return fmt.Errorf("Error creating block file")
 		}
-		_, err = m.createBlockDeviceFile(testFile, testMajor, testMinor, testPerm)
+		err = m.createBlockDeviceFile(tmpDirSafe, "testfile", 123456, testPerm)
 		Expect(err).To(HaveOccurred())
 		Expect(err.Error()).To(ContainSubstring("Error creating block file"))
 	})
 
 	It("Should not attempt to create a block device file if it exists", func() {
 		testFile := filepath.Join(tempDir, "testfile")
-		testMajor := int64(100)
-		testMinor := int64(53)
-		testPerm := "0664"
+		testPerm := os.FileMode(0664)
 		_, err = os.Create(testFile)
 		Expect(err).ToNot(HaveOccurred())
-		mknodCommand = func(deviceName string, major, minor int64, blockDevicePermissions string) ([]byte, error) {
+		mknodCommand = func(basePath *safepath.Path, deviceName string, dev uint64, blockDevicePermissions os.FileMode) error {
 			Fail("Should not get called")
-			return nil, nil
+			return nil
 		}
-		res, err := m.createBlockDeviceFile(testFile, testMajor, testMinor, testPerm)
+		err := m.createBlockDeviceFile(tmpDirSafe, "testfile", 123456, testPerm)
 		Expect(err).ToNot(HaveOccurred())
-		Expect(res).To(Equal(testFile))
 	})
 
 	It("Should remove the block device and permissions on unmount", func() {
@@ -539,26 +518,29 @@ var _ = Describe("HotplugVolume block devices", func() {
 		}
 		err = os.MkdirAll(expectedCgroupPath, 0755)
 		Expect(err).ToNot(HaveOccurred())
-		statCommand = func(fileName string) ([]byte, error) {
-			return []byte("245,32,0664,block special file"), nil
+		statSourceDevice = func(fileName *safepath.Path) (os.FileInfo, error) {
+			return fakeStat(true, 0664, 123456), nil
 		}
-		deviceFileName := filepath.Join(tempDir, "devicefile")
+		statDevice = func(fileName *safepath.Path) (os.FileInfo, error) {
+			return fakeStat(true, 0664, 123456), nil
+		}
+		isBlockDevice = func(fileName *safepath.Path) (bool, error) {
+			return true, nil
+		}
+		deviceFile, err := newFile(tempDir, "devicefile")
+		Expect(err).ToNot(HaveOccurred())
 		denyFile := filepath.Join(expectedCgroupPath, "devices.deny")
 		listFile := filepath.Join(expectedCgroupPath, "devices.list")
-		_, err := os.Create(deviceFileName)
-		Expect(err).ToNot(HaveOccurred())
 		_, err = os.Create(denyFile)
 		Expect(err).ToNot(HaveOccurred())
 		_, err = os.Create(listFile)
 		Expect(err).ToNot(HaveOccurred())
-		err = m.unmountBlockHotplugVolumes(deviceFileName, vmi)
+		err = m.unmountBlockHotplugVolumes(deviceFile, vmi)
 		Expect(err).ToNot(HaveOccurred())
 		content, err := ioutil.ReadFile(denyFile)
 		Expect(err).ToNot(HaveOccurred())
 		// Since stat returns values in hex, we need to get hex value as int.
-		Expect("b 581:50 rwm").To(Equal(string(content)))
-		_, err = os.Stat(deviceFileName)
-		Expect(err).To(HaveOccurred())
+		Expect("b 482:64 rwm").To(Equal(string(content)))
 	})
 
 	It("Should return error if deviceFile doesn' exist", func() {
@@ -569,11 +551,15 @@ var _ = Describe("HotplugVolume block devices", func() {
 		}
 		err = os.MkdirAll(expectedCgroupPath, 0755)
 		Expect(err).ToNot(HaveOccurred())
-		statCommand = func(fileName string) ([]byte, error) {
-			return []byte("245,32,0664,block special file"), nil
+		statSourceDevice = func(fileName *safepath.Path) (os.FileInfo, error) {
+			return fakeStat(true, 0664, 123456), nil
+		}
+		statDevice = func(fileName *safepath.Path) (os.FileInfo, error) {
+			return fakeStat(true, 0664, 123456), nil
 		}
-		deviceFileName := filepath.Join(tempDir, "devicefile")
-		err = m.unmountBlockHotplugVolumes(deviceFileName, vmi)
+		deviceFile, err := newFile(tempDir, "devicefile")
+		Expect(err).ToNot(HaveOccurred())
+		err = m.unmountBlockHotplugVolumes(deviceFile, vmi)
 		Expect(err).To(HaveOccurred())
 		Expect(err.Error()).To(ContainSubstring("no such file or directory"))
 	})
@@ -587,13 +573,15 @@ var _ = Describe("HotplugVolume block devices", func() {
 		}
 		err = os.MkdirAll(expectedCgroupPath, 0755)
 		Expect(err).ToNot(HaveOccurred())
-		statCommand = func(fileName string) ([]byte, error) {
-			return []byte("245,32,0664,block special file"), nil
+		statSourceDevice = func(fileName *safepath.Path) (os.FileInfo, error) {
+			return fakeStat(true, 0644, 123456), nil
+		}
+		statDevice = func(fileName *safepath.Path) (os.FileInfo, error) {
+			return fakeStat(true, 0664, 123456), nil
 		}
-		deviceFileName := filepath.Join(tempDir, "devicefile")
-		_, err := os.Create(deviceFileName)
+		deviceFile, err := newFile(tempDir, "devicefile")
 		Expect(err).ToNot(HaveOccurred())
-		err = m.unmountBlockHotplugVolumes(deviceFileName, vmi)
+		err = m.unmountBlockHotplugVolumes(deviceFile, vmi)
 		Expect(err).To(HaveOccurred())
 		Expect(err.Error()).To(ContainSubstring("Error detecting"))
 	})
@@ -605,7 +593,7 @@ var _ = Describe("HotplugVolume filesystem volumes", func() {
 		err           error
 		vmi           *v1.VirtualMachineInstance
 		record        *vmiMountTargetRecord
-		targetPodPath string
+		targetPodPath *safepath.Path
 	)
 
 	BeforeEach(func() {
@@ -617,8 +605,7 @@ var _ = Describe("HotplugVolume filesystem volumes", func() {
 		activePods["abcd"] = "host"
 		vmi.Status.ActivePods = activePods
 
-		targetPodPath = filepath.Join(tempDir, "abcd/volumes/kubernetes.io~empty-dir/hotplug-disks")
-		err = os.MkdirAll(targetPodPath, 0755)
+		targetPodPath, err = newDir(tempDir, "abcd/volumes/kubernetes.io~empty-dir/hotplug-disks")
 		Expect(err).ToNot(HaveOccurred())
 
 		record = &vmiMountTargetRecord{}
@@ -630,8 +617,8 @@ var _ = Describe("HotplugVolume filesystem volumes", func() {
 			hotplugDiskManager:   hotplugdisk.NewHotplugDiskWithOptions(tempDir),
 		}
 
-		deviceBasePath = func(sourceUID types.UID) string {
-			return filepath.Join(tempDir, string(sourceUID), "volumes")
+		deviceBasePath = func(sourceUID types.UID) (*safepath.Path, error) {
+			return newDir(tempDir, string(sourceUID), "volumes")
 		}
 		isolationDetector = func(path string) isolation.PodIsolationDetector {
 			return &mockIsolationDetector{
@@ -652,20 +639,19 @@ var _ = Describe("HotplugVolume filesystem volumes", func() {
 	})
 
 	It("getSourcePodFile should find the disk.img file, if it exists", func() {
-		path := filepath.Join(tempDir, "ghfjk", "volumes")
-		err = os.MkdirAll(path, 0755)
-		sourcePodBasePath = func(podUID types.UID) string {
-			return path
+		path, err := newDir(tempDir, "ghfjk", "volumes")
+		Expect(err).ToNot(HaveOccurred())
+		sourcePodBasePath = func(podUID types.UID) (*safepath.Path, error) {
+			return path, nil
 		}
 		findMntByVolume = func(volumeName string, pid int) ([]byte, error) {
-			return []byte(fmt.Sprintf(findmntByVolumeRes, "pvc", path)), nil
+			return []byte(fmt.Sprintf(findmntByVolumeRes, "pvc", unsafepath.UnsafeAbsolute(path.Raw()))), nil
 		}
-		diskFile := filepath.Join(path, "disk.img")
-		_, err := os.Create(diskFile)
+		_, err = newFile(unsafepath.UnsafeAbsolute(path.Raw()), "disk.img")
 		Expect(err).ToNot(HaveOccurred())
 		file, err := m.getSourcePodFilePath("ghfjk", vmi, "pvc")
 		Expect(err).ToNot(HaveOccurred())
-		Expect(file).To(Equal(path))
+		Expect(unsafepath.UnsafeRelative(file.Raw())).To(Equal(unsafepath.UnsafeAbsolute(path.Raw())))
 	})
 
 	It("getSourcePodFile should return error if no UID", func() {
@@ -674,82 +660,78 @@ var _ = Describe("HotplugVolume filesystem volumes", func() {
 	})
 
 	It("getSourcePodFile should return error if disk.img doesn't exist", func() {
-		path := filepath.Join(tempDir, "ghfjk", "volumes")
-		err = os.MkdirAll(path, 0755)
-		sourcePodBasePath = func(podUID types.UID) string {
-			return path
-		}
+		path, err := newDir(tempDir, "ghfjk", "volumes")
 		Expect(err).ToNot(HaveOccurred())
-		_, err := m.getSourcePodFilePath("ghfjk", vmi, "")
+		sourcePodBasePath = func(podUID types.UID) (*safepath.Path, error) {
+			return path, nil
+		}
+		_, err = m.getSourcePodFilePath("ghfjk", vmi, "")
 		Expect(err).To(HaveOccurred())
 	})
 
 	It("getSourcePodFile should return error if iso detection returns error", func() {
-		expectedPath := filepath.Join(tempDir, "ghfjk", "volumes")
-		err = os.MkdirAll(expectedPath, 0755)
-		sourcePodBasePath = func(podUID types.UID) string {
-			return expectedPath
+		expectedPath, err := newDir(tempDir, "ghfjk", "volumes")
+		Expect(err).ToNot(HaveOccurred())
+		sourcePodBasePath = func(podUID types.UID) (*safepath.Path, error) {
+			return expectedPath, nil
 		}
 		isolationDetector = func(path string) isolation.PodIsolationDetector {
 			return &mockIsolationDetector{
-				pid: 40,
+				pid: 9999,
 			}
 		}
 
-		Expect(err).ToNot(HaveOccurred())
-		_, err := m.getSourcePodFilePath("ghfjk", vmi, "")
+		_, err = m.getSourcePodFilePath("ghfjk", vmi, "")
 		Expect(err).To(HaveOccurred())
 		Expect(err.Error()).To(ContainSubstring("isolation error"))
 	})
 
 	It("getSourcePodFile should return error if find mounts returns error", func() {
-		expectedPath := filepath.Join(tempDir, "ghfjk", "volumes")
-		err = os.MkdirAll(expectedPath, 0755)
-		sourcePodBasePath = func(podUID types.UID) string {
-			return expectedPath
+		expectedPath, err := newDir(tempDir, "ghfjk", "volumes")
+		Expect(err).ToNot(HaveOccurred())
+		sourcePodBasePath = func(podUID types.UID) (*safepath.Path, error) {
+			return expectedPath, nil
 		}
 		findMntByVolume = func(volumeName string, pid int) ([]byte, error) {
 			return []byte(""), fmt.Errorf("findmnt error")
 		}
 
-		Expect(err).ToNot(HaveOccurred())
-		_, err := m.getSourcePodFilePath("ghfjk", vmi, "")
+		_, err = m.getSourcePodFilePath("ghfjk", vmi, "")
 		Expect(err).To(HaveOccurred())
 		Expect(err.Error()).To(ContainSubstring("findmnt error"))
 	})
 
 	It("getSourcePodFile should return the findmnt value", func() {
-		expectedPath := filepath.Join(tempDir, "ghfjk", "volumes")
-		err = os.MkdirAll(expectedPath, 0755)
-		sourcePodBasePath = func(podUID types.UID) string {
-			return expectedPath
+		expectedPath, err := newDir(tempDir, "ghfjk", "volumes")
+		Expect(err).ToNot(HaveOccurred())
+		sourcePodBasePath = func(podUID types.UID) (*safepath.Path, error) {
+			return expectedPath, nil
 		}
 		findMntByVolume = func(volumeName string, pid int) ([]byte, error) {
-			return []byte(fmt.Sprintf(findmntByVolumeRes, "pvc", expectedPath)), nil
+			return []byte(fmt.Sprintf(findmntByVolumeRes, "pvc", unsafepath.UnsafeAbsolute(expectedPath.Raw()))), nil
 		}
 
-		Expect(err).ToNot(HaveOccurred())
 		res, err := m.getSourcePodFilePath("ghfjk", vmi, "pvc")
 		Expect(err).ToNot(HaveOccurred())
-		Expect(res).To(Equal(expectedPath))
+		Expect(unsafepath.UnsafeRelative(res.Raw())).To(Equal(unsafepath.UnsafeAbsolute(expectedPath.Raw())))
 	})
 
 	It("should properly mount and unmount filesystem", func() {
 		sourcePodUID := "ghfjk"
-		path := filepath.Join(tempDir, sourcePodUID, "volumes", "disk.img")
-		err = os.MkdirAll(path, 0755)
-		sourcePodBasePath = func(podUID types.UID) string {
-			return path
+		path, err := newDir(tempDir, sourcePodUID, "volumes")
+		Expect(err).ToNot(HaveOccurred())
+		sourcePodBasePath = func(podUID types.UID) (*safepath.Path, error) {
+			return path, nil
 		}
-		diskFile := filepath.Join(path, "disk.img")
-		_, err := os.Create(diskFile)
+		diskFile, err := newFile(unsafepath.UnsafeAbsolute(path.Raw()), "disk.img")
 		Expect(err).ToNot(HaveOccurred())
 		findMntByVolume = func(volumeName string, pid int) ([]byte, error) {
-			return []byte(fmt.Sprintf(findmntByVolumeRes, "testvolume", path)), nil
+			return []byte(fmt.Sprintf(findmntByVolumeRes, "testvolume", unsafepath.UnsafeAbsolute(path.Raw()))), nil
 		}
-		targetFilePath := filepath.Join(targetPodPath, "testvolume.img")
-		mountCommand = func(sourcePath, targetPath string) ([]byte, error) {
-			Expect(sourcePath).To(Equal(diskFile))
+		targetFilePath, err := newFile(unsafepath.UnsafeAbsolute(targetPodPath.Raw()), "testvolume.img")
+		Expect(err).ToNot(HaveOccurred())
+		mountCommand = func(sourcePath, targetPath *safepath.Path) ([]byte, error) {
+			Expect(unsafepath.UnsafeRelative(sourcePath.Raw())).To(Equal(unsafepath.UnsafeAbsolute(diskFile.Raw())))
 			Expect(targetPath).To(Equal(targetFilePath))
 			return []byte("Success"), nil
 		}
@@ -757,28 +739,27 @@ var _ = Describe("HotplugVolume filesystem volumes", func() {
 		err = m.mountFileSystemHotplugVolume(vmi, "testvolume", types.UID(sourcePodUID), record)
 		Expect(err).ToNot(HaveOccurred())
 		Expect(len(record.MountTargetEntries)).To(Equal(1))
-		Expect(record.MountTargetEntries[0].TargetFile).To(Equal(targetFilePath))
+		Expect(record.MountTargetEntries[0].TargetFile).To(Equal(unsafepath.UnsafeAbsolute(targetFilePath.Raw())))
 
-		unmountCommand = func(diskPath string) ([]byte, error) {
+		unmountCommand = func(diskPath *safepath.Path) ([]byte, error) {
 			Expect(targetFilePath).To(Equal(diskPath))
 			return []byte("Success"), nil
 		}
 
-		isMounted = func(diskPath string) (bool, error) {
+		isMounted = func(diskPath *safepath.Path) (bool, error) {
 			Expect(targetFilePath).To(Equal(diskPath))
 			return true, nil
 		}
 
-		err = m.unmountFileSystemHotplugVolumes(record.MountTargetEntries[0].TargetFile)
+		err = m.unmountFileSystemHotplugVolumes(targetFilePath)
 		Expect(err).ToNot(HaveOccurred())
-		_, err = os.Stat(targetFilePath)
-		Expect(err).To(HaveOccurred())
 	})
 
 	It("unmountFileSystemHotplugVolumes should return error if isMounted returns error", func() {
-		testPath := "test"
-		isMounted = func(diskPath string) (bool, error) {
-			Expect(testPath).To(Equal(diskPath))
+		testPath, err := newFile(tempDir, "test")
+		Expect(err).ToNot(HaveOccurred())
+		isMounted = func(path *safepath.Path) (bool, error) {
+			Expect(testPath).To(Equal(path))
 			return false, fmt.Errorf("isMounted error")
 		}
 
@@ -788,8 +769,9 @@ var _ = Describe("HotplugVolume filesystem volumes", func() {
 	})
 
 	It("unmountFileSystemHotplugVolumes should return nil if isMounted returns false", func() {
-		testPath := "test"
-		isMounted = func(diskPath string) (bool, error) {
+		testPath, err := newFile(tempDir, "test")
+		Expect(err).ToNot(HaveOccurred())
+		isMounted = func(diskPath *safepath.Path) (bool, error) {
 			Expect(testPath).To(Equal(diskPath))
 			return false, nil
 		}
@@ -799,12 +781,13 @@ var _ = Describe("HotplugVolume filesystem volumes", func() {
 	})
 
 	It("unmountFileSystemHotplugVolumes should return error if unmountCommand returns error", func() {
-		testPath := "test"
-		isMounted = func(diskPath string) (bool, error) {
+		testPath, err := newFile(tempDir, "test")
+		Expect(err).ToNot(HaveOccurred())
+		isMounted = func(diskPath *safepath.Path) (bool, error) {
 			Expect(testPath).To(Equal(diskPath))
 			return true, nil
 		}
-		unmountCommand = func(diskPath string) ([]byte, error) {
+		unmountCommand = func(diskPath *safepath.Path) ([]byte, error) {
 			return []byte("Failure"), fmt.Errorf("unmount error")
 		}
 
@@ -825,6 +808,8 @@ var _ = Describe("HotplugVolume volumes", func() {
 	BeforeEach(func() {
 		tempDir, err = ioutil.TempDir("", "hotplug-volume-test")
 		Expect(err).ToNot(HaveOccurred())
+		tmpDirSafe, err = safepath.JoinAndResolveWithRelativeRoot(tempDir)
+		Expect(err).ToNot(HaveOccurred())
 		vmi = api.NewMinimalVMI("fake-vmi")
 		vmi.UID = "1234"
 		activePods := make(map[types.UID]string, 0)
